// 获取全局唯一的录音管理器
const recorderManager = wx.getRecorderManager();
/*
import { connect } from '/utils/mqtt/mqtt.js';

const client = connect('wxs://mqtt服务器地址', {
  clientId: '微信小程序客户端ID'
});

client.on('connect', function () {
  console.log('连接成功');
});

client.on('error', function (err) {
  console.log('连接失败:', err);
});*/

Page({
  // 页面的初始数据
  data: {
  },

  // 长按开始录音
  startRecord: function() {
    wx.authorize({
      scope: 'scope.record',
      success: () => { // 使用箭头函数
        this.record();
      },
      fail: () => {
        this.promptForRecordPermission();
      }
    });
  },
  record: function() {
    // 配置录音参数
    const options = {
      duration: 10000, // 录音最长时长，单位 ms
      sampleRate: 16000, // 采样率
      numberOfChannels: 1, // 录音通道数
      encodeBitRate: 96000, // 编码码率
      format: 'mp3', // 音频格式，有效值 aac/mp3
    };
    recorderManager.start(options);
    recorderManager.onStart(() => {
      console.log('recorder start');
    });
    // 错误回调
    recorderManager.onError((res) => {
      console.log(res);
    });
  },

  promptForRecordPermission: function() {
     // 用户拒绝授权，可以提示用户打开设置页授权
    wx.showModal({
      title: '提示',
      content: '需要您授权录音权限',
      showCancel: false,
      success(modalSuccess) {
        wx.openSetting({
          success(settingdata) {
            if (settingdata.authSetting['scope.record']) {
              // 用户打开设置页授权成功
            } else {
              // 用户打开设置页仍然拒绝授权
            }
          }
        });
      }
    });
  },

// 松开结束录音并上传文件
stopRecord: function() {
  const that = this;
  recorderManager.stop();
  recorderManager.onStop((res) => {
    console.log('recorder stop', res);
    const { tempFilePath } = res;
    // 调用上传函数
    that.uploadAudio(tempFilePath);
  });
},

// 上传音频文件到服务器
uploadAudio: function(filePath) {
  wx.uploadFile({
    url: 'http://soso1.top.cn/upload', // 开发者服务器的URL
    filePath: filePath,
    name: 'file', // 后端通过这个字段获取上传的文件
    header: {
      'content-type': 'multipart/form-data'
    },
    formData: {
      'user': 'test' // 其他需要一同提交的数据
    },
    success(response) {
      const data = JSON.parse(response.data);
      console.log(data.result);  // 输出处理结果
  },
  fail(error) {
      console.error('上传失败', error);
  }
  });
},

goToCameraPage: function() {
  wx.navigateTo({
    url: '/pages/cameraPage/cameraPage'
  });
},
/*
sendOn: function() {
  client.publish('stm32', '0');  // 'your/topic'是你的MQTT主题
  console.log('发送 “开” 命令');
},
sendOff: function() {
  client.publish('stm32', '1');
  console.log('发送 “关” 命令');
}*/

});


